#define BONE3D_INC



//

// Stuff for a 3d engine.

// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).

// aka hackCraft

//



#include "psi3d.h"



class cBone;

class cBody;

class cAniBone;

class cAniBody;

class cAnime;





class cBone {

  public: 

  char               *mName;

  cMatrix             mLimb;

  cMatrix             mMatrix;

  cVector             mUBase;  // up joint position in the unanimated Body

  cVector             mLBase;

// low -^
  cVector             mUJoint; // up joint in animated

  cVector             mLJoint;
// low -^
  cVector             mOUJoint; // old up joint in animated  
  cVector             mOLJoint; // old low -^
  cVector             mLength;

  cVector             mCenter;

  cVector             mAnim;

  cBone              *mChildren;

  cBone              *mNext;

  SCALAR              mTimer;

  public:

                      cBone();

  BOOLEAN             Hit(cSphere other);

  INTEG               FindBone(char *name, INTEG n, cBone *array);

  void                Scale(SCALAR f);
  void                Animate(SCALAR delta, INTEG n, cVector *keyFrames);

  void                BaseToWorld(cMatrix super, cVector length);

  void                ToWorld(cMatrix super, cVector length);

  void                ToWorld(cMatrix super, cMatrix rsuper, cVector length);

  void                Draw(cMatrix camera);

};





class cAniBone {

  public:

  char               *mName;

  INTEG               mBone;

  INTEG               mNKFrames;

  cVector            *mKFrames;

  public:

                      cAniBone();

  void                Load(FILE *f);

};





class cAniBody { // *.ame

  public:

  char               *mName;

  INTEG               mBody;

  INTEG               mNAniBones;

  cAniBone           *mAniBones;

  public:

                      cAniBody();

  void                Load(FILE *f);

  void                Assign(INTEG n, cBone *array);

};





class cAnime {

  public:

  INTEG               mNAnimations;

  cAniBody           *mAnimations;

  public:

  void                Load(FILE *f);

  void                Assign(INTEG n, cBone *array);

};





class cBody { // *.bdy

  public:

  INTEG               mNBones;

  cBone              *mBones;

  cAnime             *mAnimations;

  public:

                      cBody();

  BOOLEAN             Hit(cSphere other);

  cBone              *LoadSub(FILE *f);

  void                Load(FILE *f);

  void                SaveSub(FILE *f, cBone *bone);

  void                Save(FILE *f);

  void                Scale(SCALAR f);

  INTEG               Select(cVector pos);

  void                Drag(cVector pos);

};







