#include "psi3d.h"
 
 
void cHBmp::Draw(cMatrix c, INTEG x, INTEG z) 
{ 
  INTEG i, j; 
  SCALAR h, t, ts = 1.0/mWidth, t1, t2, a1, a2, b; 
  glColor4f(1.0, 1.0, 1.0, 1.0); 
  glDisable(GL_FOG); 
  glEnable(GL_TEXTURE_2D); 
  glEnable(GL_CULL_FACE); 
  glLoadMatrixf(c.mM); 
  glBindTexture(GL_TEXTURE_2D, mTex[5]); 
  for (j=0; j<mHeight; j++)
  { 
    a1 = ((j<<mShift)+0); 
    a2 = ((j<<mShift)+(1<<mShift)); 
    t = x * ts; 
    t1 = SCALAR(j+0+z) / mHeight; 
    t2 = SCALAR(j+1+z) / mHeight; 
    glBegin(GL_TRIANGLE_STRIP); 
    for (i=0; i<mWidth; i++) 
    { 
      b = i<<mShift; 
 
      h = GetPixel(i+x, j+z, 0)>>mHShift; 
      glTexCoord2f(t, t1); 
      glColor3f(h*50, h, 50-h*50); 
      glVertex3f(b+x-24, h, a1+z-24); 
 
      h = GetPixel(i+x, j+z+1, 0)*0.025; 
      glTexCoord2f(t, t2); 
      glColor3f(h*50, h, 50-h*50); 
      glVertex3f(b+x-24, h, a2+z-24); 
       
      t += ts; 
    }; 
    glEnd(); 
  }; 
  glDisable(GL_CULL_FACE); 
} 
 
 
void cHBmp::Draw(cMatrix c)
{ 
  INTEG i, j; 
  BYTE ground, tid; 
  SCALAR s, h, a1, a2, b; 
  glColor4f(1.0, 1.0, 1.0, 1.0); 
  glEnable(GL_TEXTURE_2D); 
  glEnable(GL_CULL_FACE); 
  glLoadMatrixf(c.mM); 
  for (j=0; j<mHeight-1; j++) 
  { 
    a1 = (j + 0)<<mShift;
    a2 = (j + 1)<<mShift;
    i = 1; 
    ground = (GetPixel(i, j, 1)%4) + 1; 
    do { 
      i--;
      tid = ground;
      glBindTexture(GL_TEXTURE_2D, mTex[tid]); 
      glBegin(GL_TRIANGLE_STRIP); 
      do { 
          b = (i)<<mShift;
 
          h = GetPixel(i, j, 0)>>mHShift;
          s = GetPixel(i, j, 2)/256.0f; 
          glTexCoord2i((i%2)<<0, 0<<0); 
          glColor3f(s, s, s); 
          glVertex3f(b, h, a1); 
 
          h = GetPixel(i, j+1, 0)>>mHShift; 
          s = GetPixel(i, j+1, 2)/256.0f; 
          glTexCoord2i((i%2)<<0, 1<<0); 
          glColor3f(s, s, s); 
          glVertex3f(b, h, a2); 
 
          ground = (GetPixel(i, j, 1)%4) + 1; 
          i++; 
        } while ((tid == ground) && (i < mWidth)); 
      glEnd(); 
    } while (i < mWidth); 
  }; 
  glDisable(GL_CULL_FACE); 
} 


void cHBmp::Draw(cMatrix c, INTEG width, INTEG depth, INTEG precision, INTEG xpos, INTEG zpos)
{
  INTEG i, j;
  INTEG e, f;
  BYTE ground, tid;
  SCALAR s, h, a1, a2, b;
  glColor4f(1.0, 1.0, 1.0, 1.0);
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_CULL_FACE);
  glLoadMatrixf(c.mM);
  for (j=0; j<depth-precision; j+=precision)
  {
    f = ((j + zpos) - (depth>>1));
    if ((f < 0) || (f >= mHeight)) continue;
    a1 = (j - (depth>>1) + 0)<<mShift;
    a2 = (j - (depth>>1) + precision)<<mShift;
    i = precision;
    e = ((0 + xpos) - (width>>1));
    ground = (GetPixel(e, f, 1)%4) + 1;
    do {
      i -= precision;
      tid = ground;
      glBindTexture(GL_TEXTURE_2D, mTex[tid]);
      glBegin(GL_TRIANGLE_STRIP);
      do {
          e = ((i + xpos) - (width>>1));
          if (e >= mWidth) {
            i = width;
            break;
          };
          if (e >= 0) {
            b = (i - (width>>1))<<mShift;

            h = GetPixel(e, f, 0)>>mHShift;
            s = GetPixel(e, f, 2)/256.0f;
            glTexCoord2i((e%2)<<0, 0<<0);
            glColor3f(s, s, s);
            glVertex3f(b+(xpos<<mShift), h, a1+(zpos<<mShift));

            h = GetPixel(e, f+precision, 0)>>mHShift;
            s = GetPixel(e, f+precision, 2)/256.0f;
            glTexCoord2i((e%2)<<0, 1<<0);
            glColor3f(s, s, s);
            glVertex3f(b+(xpos<<mShift), h, a2+(zpos<<mShift));

            ground = (GetPixel(e, f, 1)%4) + 1;
          };
          i += precision;
        } while ((tid == ground) && (i < width));
      glEnd();
    } while (i < width);
  };
  glDisable(GL_CULL_FACE);
}


void cHBmp::CastShadows() 
{ 
  INTEG i, j, c; 
  for (j=0; j<mHeight; j++) { 
    for (i=0; i<mWidth; i++) { 
      if ((i<1) || (j<1)) { 
        SetPixel(i, j, 2, 255); 
      } else { 
        c = 127 - (GetPixel(i-1, j-1, 0) - GetPixel(i, j+1, 0))*2; 
        c = fitarea(c, 15, 255); 
        SetPixel(i, j, 2, c); 
      }; 
    }; 
  }; 
} 


SCALAR cHBmp::GetHeight(cVector v)
{
  cPlane  e[2];
  cVector p[4], n[2];
  INTEG x0, x1;
  INTEG z0, z1;
  SCALAR m0, m1, h0, h1, h2, h3;
  x0 = (INTEG(v.mV[X])>>mShift)+1;
  z0 = (INTEG(v.mV[Z])>>mShift);
  x1 = x0 - 1;
  z1 = z0 + 1;
  h0 = GetPixel(x0, z0, 0)>>mHShift;
  h1 = GetPixel(x1, z0, 0)>>mHShift;
  h2 = GetPixel(x0, z1, 0)>>mHShift;
  h3 = GetPixel(x1, z1, 0)>>mHShift;
  p[0].Set(x0<<mShift, h0, z0<<mShift);
  p[1].Set(x1<<mShift, h1, z0<<mShift);
  p[2].Set(x0<<mShift, h2, z1<<mShift);
  p[3].Set(x1<<mShift, h3, z1<<mShift);
  makeNormal(n[0].mV, p[0].mV, p[2].mV, p[3].mV);
  makeNormal(n[1].mV, p[0].mV, p[1].mV, p[3].mV);
  e[0].Set(n[0], calcD(n[0].mV, p[0].mV));
  e[1].Set(n[1], calcD(n[1].mV, p[1].mV));
  m0 = calcY(e[0].mV.mV, v.mV, e[0].mV.mV[D]);
  m1 = calcY(e[1].mV.mV, v.mV, e[1].mV.mV[D]);
  cPlane a;
  cVector h = p[0];
  h.mV[Y] += 1;
  makeNormal(n[0].mV, h.mV, p[0].mV, p[3].mV);
  a.Set(n[0], calcD(n[0].mV, p[0].mV));
  if (a.Distance(v) < 0) {
    return m0;
  } else {
    return m1;
  };
}


void cHBmp::MarkField(cVector v)
{
  cPlane  e[2];
  cVector p[8], n[2];
  INTEG x0, x1;
  INTEG z0, z1;
  SCALAR m0, m1, h0, h1, h2, h3;
  x0 = INTEG(v.mV[X])+1;
  z0 = INTEG(v.mV[Z]);
  x1 = x0 - 1;
  z1 = z0 + 1;
  h0 = GetPixel(x0, z0, 0)>>mHShift;
  h1 = GetPixel(x1, z0, 0)>>mHShift;
  h2 = GetPixel(x0, z1, 0)>>mHShift;
  h3 = GetPixel(x1, z1, 0)>>mHShift;
  p[0].Set(x0, h0, z0); 
  p[1].Set(x1, h1, z0); 
  p[2].Set(x0, h2, z1); 
  p[3].Set(x1, h3, z1); 
  p[4].Set(x0, 0.1+h0, z0); 
  p[5].Set(x1, 0.1+h1, z0); 
  p[6].Set(x0, 0.1+h2, z1); 
  p[7].Set(x1, 0.1+h3, z1); 
  glDisable(GL_TEXTURE_2D); 
  glColor4f(0.5, 0.0, 0.0, 0.5); 
  glBegin(GL_QUADS); 
    glVertex3fv(p[0].mV); 
    glVertex3fv(p[1].mV); 
    glVertex3fv(p[5].mV); 
    glVertex3fv(p[4].mV); 
 
    glVertex3fv(p[1].mV); 
    glVertex3fv(p[3].mV); 
    glVertex3fv(p[7].mV); 
    glVertex3fv(p[5].mV); 
 
    glVertex3fv(p[2].mV); 
    glVertex3fv(p[3].mV); 
    glVertex3fv(p[7].mV); 
    glVertex3fv(p[6].mV); 
 
    glVertex3fv(p[0].mV); 
    glVertex3fv(p[2].mV); 
    glVertex3fv(p[6].mV); 
    glVertex3fv(p[4].mV); 
  glEnd(); 
  glColor4f(0.0, 0.0, 0.5, 0.5); 
  glBegin(GL_TRIANGLES); 
    glVertex3fv(p[4].mV); // 0 
    glVertex3fv(p[5].mV); // 1 corner 
    glVertex3fv(p[7].mV); // 3 
  glEnd(); 
  glColor4f(0.0, 0.5, 0.0, 0.5); 
  glBegin(GL_TRIANGLES); 
    glVertex3fv(p[4].mV); // 0 
    glVertex3fv(p[6].mV); // 2 corner 
    glVertex3fv(p[7].mV); // 3 
  glEnd(); 
} 



