#include "psi3d.h"


//
// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).
//



void cParticle::Draw(cMatrix camera, cVector facing)
{
  cMatrix cm;
  SCALAR x, y, z;
  x = mRotation.mV[X];
  y = mRotation.mV[Y];
  z = mRotation.mV[Z];
  if (mAlignTo & 1) x += facing.mV[X];
  if (mAlignTo & 2) y += facing.mV[Y];
  if (mAlignTo & 4) z += facing.mV[Z];
  cm.RotXYZ(x, y, z);
  cm.MovRel(mPosition.mV[X], mPosition.mV[Y], mPosition.mV[Z]);
  cm.Mul(camera);
  glLoadMatrixf(cm.mM);
  SCALAR b = -mHeight / 2;
  SCALAR a = +mWidth / 2;
  glBegin(GL_QUADS);
    glTexCoord2f(0.0, 0.0);
    glVertex3f(+a, +b, 0.0);
    glTexCoord2f(1.0, 0.0);
    glVertex3f(-a, +b, 0.0);
    glTexCoord2f(1.0, 1.0);
    glVertex3f(-a, -b, 0.0);
    glTexCoord2f(0.0, 1);
    glVertex3f(+a, -b, 0.0);
  glEnd();
}


