#define SOUND_INC

#include "psi3d.h"



class cSound {
  public:
  const static INTEG MAX_SOUNDS = 256;
  const static INTEG MAX_SOUNDS_PLAYING = 32;
  public:
  SCALAR             mMaster;
  SCALAR             mVolumeL;
  SCALAR             mVolumeR;
  INTEG              mChannels;
  INTEG              mRate;
  INTEG              mBits;
  public:
  void              *mSystemHandle;
  INTEG              mNRegistered;
  char              *mFNames[MAX_SOUNDS];
  INTEG              mPriority[MAX_SOUNDS];
  DWORD              mHandles[MAX_SOUNDS];
  public:
  INTEG              mNPlaying;                              // later for sound scheduling maybe
  DWORD              mPlayingHandles[MAX_SOUNDS_PLAYING];
  INTEG              mPlayingPriority[MAX_SOUNDS_PLAYING];
  public:
                     cSound();
                    ~cSound();
  void               InitSystem(char *address, WORD port);
  void               UpdateSystem();                          // event handler, call once per frame
  void               KillSystem();
  void               SetMasterVolume(SCALAR v);               // volume factor for playing
  void               SetVolume(SCALAR l, SCALAR r);
  void               SetChannels(INTEG n);
  void               SetRate(INTEG n);
  void               SetBits(INTEG n);
  DWORD              RegisterSound(char *fname, INTEG priority);
  DWORD              InitSound(DWORD handle, INTEG begin, INTEG repeat, SCALAR l, SCALAR r);
  void               KillSound(DWORD handle);
};



