#define UTIL3D_INC

#include "psi3d.h"


class cTimer {
  public:
  DWORD              mOldClock;
  DWORD              mNewClock;

  SCALAR             mSPF; // seconds per frame
  SCALAR             mFPS; // frames per second
  public:
                     cTimer();
  void               Update();
};


class cText {
  public:
    char        s[1024];
  public:
                cText();
    void        Reset();
    int         Equal(char *str);
    int         Length();
    char       *Lower();
    char       *Upper();
    char       *Assign(char *str);
    char       *Append(char *str);
    char       *Front(char *str);
    char       *GetPtr();
};


class cBmp {

  public:

  INTEG         mWidth;
  INTEG         mHeight;
  INTEG         mDepth;
  BYTE         *mBmp;
  public:
                cBmp();
  void          Resize(INTEG width, INTEG height, INTEG depth);
  BOOLEAN       Inside(INTEG x, INTEG y);
  BOOLEAN       LoadTga(char *fname);
  void          MakeAlpha(cVector alphaColor);
  void          SetPixel(INTEG x, INTEG y, INTEG z, BYTE c);
  BYTE          GetPixel(INTEG x, INTEG y, INTEG z);
  void          Clear(INTEG z, BYTE c);
  void          Clear(INTEG x, INTEG y, INTEG z, INTEG w, INTEG h, BYTE c);
  void          CopyLayer(cBmp *srcBmp, INTEG srcZ, INTEG dstZ);
  void          Plasma(INTEG x, INTEG y, INTEG z, INTEG w, INTEG h, BYTE c);
  void          Add(INTEG z, BYTE c);
  void          Mul(INTEG z, SCALAR m);
  void          Mul(INTEG z, BYTE m);
  void          Div(INTEG z, SCALAR d);
  void          Div(INTEG z, BYTE d);
  BOOLEAN       glUpload(WORD id);
  BOOLEAN       glRegister(BOOLEAN mipmap, WORD &id);
};



