//

// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).

//



#include "psi3d.h"





cViewer::cViewer()

{

  mType  = 0;

  mX     = 0;

  mY     = 0;

  mW     = 0;

  mH     = 0;

}





void cViewer::Use()

{

  glViewport(mX, mY, mW, mH);

  glMatrixMode(GL_PROJECTION);

  glLoadIdentity();

  if (mType == 0) {

    gluPerspective(45.0, GLdouble(mW) / GLdouble(mH), 0.15, 45000.0);

    glDepthFunc(GL_LEQUAL);

  } else if (mType == 1) {

    glOrtho(0, mW, 0, mH, -45000.0, 45000.0);

    glDepthFunc(GL_GEQUAL);

  } else if (mType == 2) {

    glOrtho(0, 1, 0, 1, -45000.0, 45000.0);

    glDepthFunc(GL_GEQUAL);

  } else if (mType == 3) {

    glOrtho(-0.5, 0.5, -0.5, 0.5, -45000.0, 45000.0);

    glDepthFunc(GL_GEQUAL);

  };

  glMatrixMode(GL_MODELVIEW);

  glLoadIdentity();

}





void cViewer::Move(INTEG x, INTEG y)

{

  mX=x;

  mY=y;

}





void cViewer::Resize(INTEG w, INTEG h)

{

  mW=w;

  mH=h;

}



