// User changeable keys which are

// compiled into the program.

// Will be changed later for

// being able to change them

// during runtime.

#define FIRE_KEY            ' '
#define JUMPJET_KEY         'j'
#define CAMERA_KEY          'c'
#define WIREFRAME_KEY       'w'
#define CONSOLE0_KEY        'k'
#define CONSOLE1_KEY        'K'
#define PAUSE_KEY           'p'

// If your computer is fast enough to get a high
// fps rate and your 1Ghz cpu still has enough
// sparetime you might consider setting this
// as high as you want (4000+ makes sense) to
// enable other programs to run properly in the
// background.
#define USLEEP_PER_FRAME_WASTE 0

// This gives other programs time to run while
// the game is paused anyway, you just shouldn't
// set it as high that you've got to wait one hour
// until you can suspend the game...
#define USLEEP_DURING_PAUSE 10000


// change 'nUSE_3DFX' to 'USE_3DFX' if
// you want to use your 3dfx card.
// Newer versions of mesa seem to use 3dfx cards
// automatically but you need to use this switch
// anyway in that case because there are problems
// with the aspect ratio of the screen and you
// will encounter problems with the mouse because
// it can left the visible screen.
// So if you own a 3dfx card better switch this on.
// And you can change the resolution which will be
// used on that kind of cards.
#define nUSE_3DFX
#define MAX_3DFX_XRES 640
#define MAX_3DFX_YRES 480


// This key is for use with X Mesa to switch 
// between fullscreen and windowed mode.
#define XMODE_KEY          'f'

// Wether we use the X version of mesa or not.
#define USE_XMESA YES

// For use with X Mesa, don't say YES if mesa
// runs unaccellerated on your box.
#define nSTART_WITH_XFULLSCREEN


// For users without hardware accelleration

// it might be better to set this to YES for

// a Non-Slide-Show-Framerate.

#define START_WITH_WIREFRAME       NO



// Set this to YES if you want to have external

// camera view by default.

#define START_WITH_EXTERNAL_CAM    NO



// Set this to YES if you experience problems

// with the joystick control (ie. if joystick

// works in general but it sucks).

// ps. I've switched it to YES because there  
// will be problems with the current version  
// of the joystick driver.  
#define JOYSTICK_CONTROL_SUX       YES


// LinWarrior 3D will jump to that directory
// once started and will try to find all the
// textures, objects, ... in its subdirs.
// Must end with a slash ("/")!
#define DATA_DIRECTORY "/usr/share/lw3d/"

// Directory in which the lw3d binary is in.
// This define isn't used currently but this
// might change...
// Must end with a slash ("/")!
#define BIN_DIRECTORY "/usr/bin/"

// Start with 3d console 0/1 enabled/disabeld.
// These consoles might be wasteful for slow          __
// computers, but remember con0 gives you runtime    / /    __
// information, so...do what you want but think          / /
// about the omen:   ;)                                    
#define START_WITH_CONSOLE_0 YES
#define START_WITH_CONSOLE_1 NO



