#include <stdlib.h>



//

// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).

//





#include "state.h"







cState::cState()

{

  ClearState();

}





void cState::ClearState()

{

  mStatePointer = 0;

  OverideState(0, NULL, NULL, NULL, NULL);

}





void cState::OverideState(INTEG state, void *objectA, void *objectB,

                                       void *objectC, void *objectD)

{

  mStateStack[mStatePointer] = state;

  mObjectStackA[mStatePointer] = objectA;

  mObjectStackB[mStatePointer] = objectB;

  mObjectStackC[mStatePointer] = objectC;

  mObjectStackD[mStatePointer] = objectD;

}





void cState::NewState(INTEG state, void *objectA, void *objectB,

                                   void *objectC, void *objectD)

{

  mStatePointer++;

  mStateStack[mStatePointer] = state;

  mObjectStackA[mStatePointer] = objectA;

  mObjectStackB[mStatePointer] = objectB;

  mObjectStackC[mStatePointer] = objectC;

  mObjectStackD[mStatePointer] = objectD;

}





void cState::OldState()

{

  mStatePointer--;

  if (mStatePointer<0) ClearState();

}





INTEG cState::GetState()

{

  return mStateStack[mStatePointer];

}





void *cState::GetObjectA()

{

  return mObjectStackA[mStatePointer];

}





void *cState::GetObjectB()

{

  return mObjectStackB[mStatePointer];

}





void *cState::GetObjectC()

{

  return mObjectStackC[mStatePointer];

}





void *cState::GetObjectD()

{

  return mObjectStackD[mStatePointer];

}







