#ifndef STATE_INC

#define STATE_INC



//

// Stack Based State Engine.

//

// The State Engine is able to remember old states and

// to return to them in a <First In - Last Out> manner.

//

// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).

// aka hackCraft

//

// ps. Thanx to the MW2:Mercenaries Team for providing

//     good and interesting docs about their AI - which

//     comes with the game itself.

//



#include <psi3d/psi3d.h>






class cState {

  public:

  const static INTEG MAX_ONSTACK = 32;

  public:

  INTEG              mStatePointer;

  INTEG              mStateStack[MAX_ONSTACK];

  void              *mObjectStackA[MAX_ONSTACK];

  void              *mObjectStackB[MAX_ONSTACK];

  void              *mObjectStackC[MAX_ONSTACK];

  void              *mObjectStackD[MAX_ONSTACK];

  public:

                     cState();

  void               ClearState();

  void               OverideState(INTEG state, void *objectA, void *objectB, void *objectC, void *objectD);

  void               NewState(INTEG state, void *objectA, void *objectB, void *objectC, void *objectD);

  void               OldState();

  INTEG              GetState();

  void              *GetObjectA();

  void              *GetObjectB();

  void              *GetObjectC();

  void              *GetObjectD();

};





#endif



